/**
 * CV2.java
 *
 * File generated from the medication2::CV2 uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.medication2;

import java.util.List;

// End of user code
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;


/**
 * Description of the class CV2.
 *
 * 
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "CV", propOrder = {
	"originalText1"
})
@XmlRootElement(name = "CV2")
public class CV2 extends net.ihe.gazelle.medication2.CE2 implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	/**
	 *                          The text or phrase used as
	                                the basis for the coding.                      .
	 */
	@XmlElement(name = "originalText", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication2.ED2 originalText1;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return originalText1.
	 * @return originalText1 :                          The text or phrase used as
	                                the basis for the coding.                      
	 */
	public net.ihe.gazelle.medication2.ED2 getOriginalText1() {
	    return originalText1;
	}
	
	/**
	 * Set a value to attribute originalText1.
	 * @param originalText1 :                          The text or phrase used as
	                                the basis for the coding.                      .
	 */
	public void setOriginalText1(net.ihe.gazelle.medication2.ED2 originalText1) {
	    this.originalText1 = originalText1;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.medication2");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:epsos-org:ep:medication", "CV2").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(CV2 cV2, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (cV2 != null){
   			net.ihe.gazelle.medication2.CE2.validateByModule(cV2, _location, cvm, diagnostic);
			net.ihe.gazelle.medication2.ED2.validateByModule(cV2.getOriginalText1(), _location + "/originalText", cvm, diagnostic);
    	}
    }

}
